'' =================================================================================================
''
''   File....... jm_pca8574.spin
''   Purpose.... PCA8574 interface (allows comms with up to 8 devices on same buss)
''   Author..... Jon "JonnyMac" McPhalen
''               Copyright (c) 2013-14 Jon McPhalen
''               -- see below for terms of use
''   E-mail..... jon@jonmcphalen.com
''   Started.... 
''   Updated.... 22 DEC 2014
''
'' =================================================================================================


con { fixed io pins }

  RX1    = 31                                                    ' programming / debug port
  TX1    = 30
  
  EE_SDA = 29                                                    ' eeprom
  EE_SCL = 28


con

  WR_8574 = %0100_000_0
  RD_8574 = %0100_000_1 
  

obj

  i2c : "jm_i2c"
  

var


pub start

'' Start PCA8574 object
'' -- uses boot eeprom buss

  startx(EE_SCL, EE_SDA)                                         ' use boot eeprom buss


pub startx(sclpin, sdapin)

'' Start PCA8574 object
'' -- sclpin and sdapin define i2c buss

  i2c.setupx(sclpin, sdapin)                                     ' connect to buss


pub write(addr, b)

'' Write byte b to PCA8574 port

  i2c.start
  i2c.write(WR_8574 | (addr << 1))
  i2c.write(b)
  i2c.stop


pub read(addr) | b

'' Read port bits from PCA8574

  i2c.start
  i2c.write(RD_8574 | (addr << 1))
  b := i2c.read(i2c#ACK)
  i2c.stop

  return b


dat { license }

{{

  Terms of Use: MIT License

  Permission is hereby granted, free of charge, to any person obtaining a copy of this
  software and associated documentation files (the "Software"), to deal in the Software
  without restriction, including without limitation the rights to use, copy, modify,
  merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
  permit persons to whom the Software is furnished to do so, subject to the following
  conditions:

  The above copyright notice and this permission notice shall be included in all copies
  or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
  INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
  PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
  HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
  OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

}}